#!/usr/bin/python
#read_EEPROM.py

#Wesentliche Hinweise zur ISP-Programmierung
#von Atmel-Controllern finden sich neben 
#den Angaben in den Datenblaettern der betreffenden #Mikrocontroller u. a. in inzwischen vergriffenen #Fachbuechern von W.Trampert sowie B.Kainka (vgl #Literaturangaben zum Beitrag).

#H. Nieder, Fruehjahr 2015
#aktualisierte Version vom Januar 2016

import sys
import time
import RPi.GPIO as GPIO


#GPIO-Pins
MOSI=8
SCK =7
MISO=25
RES=23
STR=24#Test, fuer Erweiterungen



#GPIO-Festlegungen
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)

GPIO.setup(MOSI,GPIO.OUT)
GPIO.setup(SCK,GPIO.OUT)
GPIO.setup(STR,GPIO.OUT)
GPIO.setup(RES,GPIO.OUT)
GPIO.setup(MISO,GPIO.IN)

out=GPIO.output
inp=GPIO.input
low=GPIO.LOW
hi=GPIO.HIGH

#Anfangszustand
out(STR,hi)
out(RES,low)

Byte=0
z=0

def pulse_STR():
    out(STR,low)
    time.sleep(0.01)
    out(STR,hi)

#Umwandlung Dez-->Hex
HEX_dt=("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F")
def ByteToHex(Byte):
    Lo_nib=0
    Hi_nib=0     
    Hi_nib=Byte/16
    Lo_nib=Byte%16      
    ByteHex=HEX_dt[Hi_nib]+HEX_dt[Lo_nib]      
    return ByteHex


Byte_in=0

def SPI_ein():
    out(SCK,hi)
    Byte_in=0
    Bit7=128
    n=0
    for n in range(0,8):             
        out(SCK,low)
        time.sleep(0.0001)
        if (GPIO.input(MISO)):
            Byte_in=Byte_in+Bit7               
        time.sleep(0.0001)
        out(SCK,hi)
        time.sleep(0.0001)                
        Bit7=Bit7>>1#1 Bit nach rechts schieben        
    time.sleep(0.0001)
    Ergebnis=Byte_in
    Zahl=ByteToHex(Byte_in)
    print Zahl, 



def SPI_aus(Byte):
    #Byte=255-Byte 
    Bit7_wt=128
    n=0
    for n in range(0,8):
        if (Byte & Bit7_wt) >0:
            out(MOSI,low)      
        else:
            out(MOSI,hi)
        time.sleep(0.0001)
        out(SCK,low)
        Bit7_wt=Bit7_wt>>1#1 Bit nach rechts schieben        
        time.sleep(0.0001)
        out(SCK,hi)    
    out(MOSI,hi)
   

def prog_en():
    SPI_aus(0xAC)
    SPI_aus(0x53)
    SPI_aus(0)
    SPI_aus(0)    



#Start
out(RES,hi)#Reset "einschalten"

time.sleep(0.02)

prog_en()
time.sleep(1)
prog_en()
n=0

print
n=input("Anzahl anzuzeigende Bytes: ")
print

k=0
page=0
wordzahl=0
ad=0
ad_hi=0
ad_lo=0
ad_t=0

if n<4096:
   
    
    print"                      Inhalt EEPROM AVR"
    print
    print"         0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F"
    
    print
    ad_hi=ad_t/256
    ad_lo=ad_t%256
    print ByteToHex(ad_hi),ByteToHex(ad_lo),":",
    time.sleep(0.02)
    for ad in range(0,n):
        
        SPI_aus(0xA0)
        
        ad_hi=ad/256
        ad_lo=ad%256
        SPI_aus(ad_hi)
        SPI_aus(ad_lo)
        SPI_ein()

        k=k+1
        if k==16:
            print
            k=0
            ad_t=ad_t+16
            ad_hi=ad_t/256
            ad_lo=ad_t%256
            if ad<n-1:
                print ByteToHex(ad_hi),ByteToHex(ad_lo),":",
    print               

print
print "Programmende"
print


out(MOSI,low)
out(SCK,low)
time.sleep(1)
out(RES,low)





